-- write current buffer
vim.keymap.set('n', '<leader>w', '<esc>:w<cr>', {desc = 'Write buffer', silent = true})

-- quit keymap
vim.keymap.set('n', '<leader>q', '<esc>:q<cr>', {desc = 'Quit', silent = true})

-- open nvimtree
vim.keymap.set('n', '<leader>e', '<esc>:NvimTreeToggle<cr>', {desc = 'Open file explorer', silent = true})

-- bufferline move between tabs
vim.keymap.set('n', '<S-l>', '<esc>:BufferLineCycleNext<cr>', {desc = 'Next buffer', silent = true})
vim.keymap.set('n', '<S-h>', '<esc>:BufferLineCyclePrev<cr>', {desc = 'Previous buffer', silent = true})

-- quicker window navigation
vim.keymap.set('n', '<C-h>', '<C-w>h', {desc = 'window navigation', silent = true})
vim.keymap.set('n', '<C-j>', '<C-w>j', {desc = 'window navigation', silent = true})
vim.keymap.set('n', '<C-k>', '<C-w>k', {desc = 'window navigation', silent = true})
vim.keymap.set('n', '<C-l>', '<C-w>l', {desc = 'window navigation', silent = true})

-- vsplit
vim.keymap.set('n', '<|>', ':vsplit<CR>', {desc = 'Vertical split', remap = true})

-- Enable telescope fzf native, if installed
pcall(require('telescope').load_extension, 'fzf')

-- See `:help telescope.builtin`
vim.keymap.set('n', '<leader>?', require('telescope.builtin').oldfiles, { desc = '[?] Find recently opened files' })
vim.keymap.set('n', '<leader><space>', require('telescope.builtin').buffers, { desc = '[ ] Find existing buffers' })
-- vim.keymap.set('n', '<leader>/', function()
--   -- You can pass additional configuration to telescope to change theme, layout, etc.
--   require('telescope.builtin').current_buffer_fuzzy_find(require('telescope.themes').get_dropdown {
--     winblend = 10,
--     previewer = false,
--   })
-- end, { desc = '[/] Fuzzily search in current buffer]' })

vim.keymap.set('n', '<leader>sf', require('telescope.builtin').find_files, { desc = '[S]earch [F]iles' })
vim.keymap.set('n', '<leader>sh', require('telescope.builtin').help_tags, { desc = '[S]earch [H]elp' })
vim.keymap.set('n', '<leader>sw', require('telescope.builtin').grep_string, { desc = '[S]earch current [W]ord' })
vim.keymap.set('n', '<leader>sg', require('telescope.builtin').live_grep, { desc = '[S]earch by [G]rep' })
vim.keymap.set('n', '<leader>sd', require('telescope.builtin').diagnostics, { desc = '[S]earch [D]iagnostics' })


-- Diagnostic keymaps
vim.keymap.set('n', '[d', vim.diagnostic.goto_prev)
vim.keymap.set('n', ']d', vim.diagnostic.goto_next)
-- vim.keymap.set('n', '<leader>ld', vim.diagnostic.open_float)
-- vim.keymap.set('n', '<leader>q', vim.diagnostic.setloclist)


